<?php

use Phinx\Migration\AbstractMigration;

class FormFieldWidth extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $this->table('form_field_width', ['id' => 'form_field_width_id'])
            ->addColumn('form_field_width_libelle', 'string')
            ->create()
        ;

        $this->table('form_field_width')
            ->insert([
                [
                    'form_field_width_id' => 1,
                    'form_field_width_libelle' => '100 %'
                ],
                [
                    'form_field_width_id' => 2,
                    'form_field_width_libelle' => '50 %'
                ],
            ])
            ->saveData()
        ;

        $this->table('form_field')
            ->addColumn('form_field_width_id', 'integer', ['default' => 1])
            ->addForeignKey(
                'form_field_width_id',
                'form_field_width',
                'form_field_width_id',
                ['delete' => 'CASCADE', 'update' => 'CASCADE']
            )
            ->update()
        ;
    }
}
