<?php

namespace CustomForm\Service\Component;

use Boutique;
use CustomForm\Model\Form as FormModel;
use CustomForm\Model\FormField;
use CustomForm\Model\FormResponse;
use CustomForm\Service\Form\EmptyForm;
use CustomForm\Service\InvalidFormRequestException;
use DediException;
use LogicException;
use Symfony\Component\HttpFoundation\Request;
use Form\Form as AbstractForm;

/**
 * Class Form
 */
class Form extends AbstractForm
{
    /**
     * @var FormModel $formModel
     */
    protected $formModel;

    public function __construct(FormModel $form)
    {
        parent::__construct();
        $this->setFormModel($form);
    }

    public function handle(Request $request)
    {
        $errors = parent::handle($request);
        if (!empty($errors)) {
            throw new InvalidFormRequestException($errors);
        }
    }

    /**
     * @return FormModel
     */
    public function getFormModel()
    {
        return $this->formModel;
    }

    /**
     * @param FormModel $formModel
     * @return Form
     */
    public function setFormModel($formModel)
    {
        $this->formModel = $formModel;
        return $this;
    }

    /**
     * @return Field[]
     */
    public function getFields()
    {
        return $this->fields;
    }

    /**
     * @param Field[] $fields
     * @return Form
     */
    public function setFields($fields)
    {
        $this->fields = $fields;
        return $this;
    }

//    /**
//     * @return AbstractForm
//     */
//    public function generateValidationForm()
//    {
//        $form = new EmptyForm();
//        // TODO add CustomForm as a parameter
//        $formFields = $this->getCustomForm()->getFields();
//        array_walk($formFields, function (FormField $formField) use ($form) {
//            $field = new Field($this->getName($formField));
//            $constraints = $formField->getConstraints();
//            array_walk($constraints, function (Constraint $constraint, $i) use ($field) {
//                $field->addConstraints(
//                    $i,
//                    $constraint,
//                    "Ce champs est invalide"
//                );
//            });
//            $form->add($field);
//        });
//        return $form;
//    }

//    /**
//     *
//     */
//    protected function loadFields()
//    {
//        // TODO add CustomForm as a parameter
//        // TODO return customForm
//        $customForm = $this->getCustomForm();
//        $fields = $this->getFormFieldRepo()->get(['form_id' => $customForm->getFormId()]);
//        array_walk($fields, function (array &$arrField) use ($customForm) {
//            $field = new FormField();
//            $field->hydrate($arrField);
//            $field->setConstraints($this->getConstraints($field));
//            $field->setOptions($field->fetchOptions());
//            $field->setName($this->getName($field));
//            $customForm->addFields($field);
//        });
//        return $this;
//    }

//    /**
//     *
//     */
//    public function getConstraints(FormField $field)
//    {
//        $arrConstraints = $field->fetchConstraints();
//        $constraints = array_map(function (array $arrConstraint) {
//            $mapping = [
//                FormField::CONSTRAINT_NOT_BLANK_ID => new NotBlank(),
//                FormField::CONSTRAINT_EMAIL_ID => new Mail(),
//                FormField::CONSTRAINT_FRENCH_PHONE_ID => new Phone(),
//            ];
//
//            return $mapping[$arrConstraint['form_constraint_id']];
//        }, $arrConstraints);
//        return $constraints;
//    }

    /**
     * @param Request $request
     * @throws DediException
     */
    public function save(Request $request)
    {
    }
}